import { DurationHistogram } from './durationHistogram';
import { IFieldStat, IPathErrorStats, IQueryLatencyStats, IStatsContext, Trace, ITypeStat, IContextualizedStats, ReportHeader, google, ITracesAndStats, IReport } from 'apollo-reporting-protobuf';
export declare class OurReport implements Required<IReport> {
    readonly header: ReportHeader;
    constructor(header: ReportHeader);
    readonly tracesPerQuery: Record<string, OurTracesAndStats | undefined>;
    endTime: google.protobuf.ITimestamp | null;
    tracesAndStatsByStatsReportKey(statsReportKey: string): OurTracesAndStats;
}
declare class OurTracesAndStats implements Required<ITracesAndStats> {
    readonly trace: Uint8Array[];
    readonly statsWithContext: StatsByContext;
}
declare class StatsByContext {
    readonly map: {
        [k: string]: OurContextualizedStats;
    };
    toArray(): IContextualizedStats[];
    addTrace(trace: Trace): void;
}
export declare class OurContextualizedStats implements IContextualizedStats {
    readonly statsContext: IStatsContext;
    queryLatencyStats: OurQueryLatencyStats;
    perTypeStat: {
        [k: string]: OurTypeStat;
    };
    constructor(statsContext: IStatsContext);
    addTrace(trace: Trace): void;
}
declare class OurQueryLatencyStats implements Required<IQueryLatencyStats> {
    latencyCount: DurationHistogram;
    requestCount: number;
    cacheHits: number;
    persistedQueryHits: number;
    persistedQueryMisses: number;
    cacheLatencyCount: DurationHistogram;
    rootErrorStats: OurPathErrorStats;
    requestsWithErrorsCount: number;
    publicCacheTtlCount: DurationHistogram;
    privateCacheTtlCount: DurationHistogram;
    registeredOperationCount: number;
    forbiddenOperationCount: number;
}
declare class OurPathErrorStats implements Required<IPathErrorStats> {
    children: {
        [k: string]: OurPathErrorStats;
    };
    errorsCount: number;
    requestsWithErrorsCount: number;
}
declare class OurTypeStat implements Required<ITypeStat> {
    perFieldStat: {
        [k: string]: OurFieldStat;
    };
}
declare class OurFieldStat implements Required<IFieldStat> {
    readonly returnType: string;
    errorsCount: number;
    count: number;
    requestsWithErrorsCount: number;
    latencyCount: DurationHistogram;
    constructor(returnType: string);
}
export {};
//# sourceMappingURL=stats.d.ts.map